/* ǡܥå饤֥꥽ ver1.1 1997/8/28
                  by Y.Shigesada                   */

#include "dboxlib.h"

extern COLOR colmap[256];

/* ǡܥåǡǼĥ꡼νΥ饤֥Ѥ
   ݤɬǽ˸Ƥֻ */
void inittreedata()
{
    W i;
    
    for (i = 0 ; i < MAXSCENENUM ; i++) {
	scenedata[i].num  = 0;
	scenedata[i].sdat = NULL;
    }

    for (i = 1 ; i < 11 ; i++) {
	root[i] = NULL;
    }
}

/* fdμեǥץǡܥåǡɤ */
void loadscenedata(W fd)
{
    B headder[11];
    W i, first, ok, num, err, offset;
    SCENEDATAver1_0 sdatver1_0;
    SCENEDATAver1_1 sdatver1_1;
    SCENEDATAver1_2 sdatver1_2;
    SCENEDATAver1_3 sdatver1_3;

    headder[10] = 0;
    first = 1;
    ok = 0;
    while (1) {       
	err = fnd_rec(fd, (first) ? F_TOPEND : F_NFWD,
		      1 << 31, (UH)NULL, NULL);
	first = 0;
	if (err == 31) {
	    if ((err = rea_rec(fd, 0, (B *)&headder,
			       sizeof(B) * 10, NULL, (UH)NULL)) < 0) {
		printf("rea_rec error %d\n", err);
		return;
	    }
	    if (!strncmp(headder, "SDATver1.0", 10)) {
		ok = 1;
		break;
	    }
	    if (!strncmp(headder, "SDATver1.1", 10)) {
		ok = 2;
		break;
	    }
	    if (!strncmp(headder, "SDATver1.2", 10)) {
		ok = 3;
		break;
	    }
	    if (!strncmp(headder, "SDATver1.3", 10)) {
		ok = 4;
		break;
	    }
	    if (!strncmp(headder, "SDATver1.4", 10)) {
		ok = 5;
		break;
	    }
	}
	else {
	    break;
	}
    }

    if (!ok) {
	printf("no scene data\n");
	return;
    }
    else {
	printf("scene data %s\n", headder);
    }

    offset = sizeof(B) * 10;
    while (1) {
	if ((err = rea_rec(fd, offset, (B *)&num,
			   sizeof(W), NULL, NULL)) < 0) {
	    printf("rea_rec error %d\n", err);
	    return;
	}
	if (num == -1) {
	    break;
	}
	offset += sizeof(W);
	
	printf("loading scenedata. %d\n", num);
	if ((err = rea_rec(fd, offset, (B *)&(scenedata[num].num),
			   sizeof(W), NULL, NULL)) < 0) {
	    printf("rea_rec error %d\n", err);
	    return;
	}
	offset += sizeof(W);

	scenedata[num].sdat =
	    (SCENEDATAver1_4 *)malloc(sizeof(SCENEDATAver1_4) *
				      scenedata[num].num);
	switch (ok) {
	case 1: /* ver1.0 */
	    for (i = 0 ; i < scenedata[num].num ; i++) {
		if ((err = rea_rec(fd, offset, (B *)&sdatver1_0,
				   sizeof(SCENEDATAver1_0),
				   NULL, NULL)) < 0) {
		    printf("rea_rec error0 %d\n", err);
		    return;
		}	
		scenedata[num].sdat[i].type        = sdatver1_0.type;
		scenedata[num].sdat[i].id          = sdatver1_0.id;
		scenedata[num].sdat[i].r           = sdatver1_0.r;
		scenedata[num].sdat[i].pnum        = sdatver1_0.pnum;
		scenedata[num].sdat[i].mojifgcolor = 255;
		scenedata[num].sdat[i].mojibgcolor = 0;
		scenedata[num].sdat[i].mojisizex   = 16;
		scenedata[num].sdat[i].mojisizey   = 16;
		scenedata[num].sdat[i].mojiattr    = 0;		
		offset += sizeof(SCENEDATAver1_0);
	    }
	    break;
	case 2: /* ver1.1 */
	    for (i = 0 ; i < scenedata[num].num ; i++) {
		if ((err = rea_rec(fd, offset, (B *)&sdatver1_1,
				   sizeof(SCENEDATAver1_1),
				   NULL, NULL)) < 0) {
		    printf("rea_rec error1 %d\n", err);
		    return;
		}	
		scenedata[num].sdat[i].type        = sdatver1_1.type;
		scenedata[num].sdat[i].id          = sdatver1_1.id;
		scenedata[num].sdat[i].r           = sdatver1_1.r;
		scenedata[num].sdat[i].pnum        = sdatver1_1.pnum;
		scenedata[num].sdat[i].dispmode    = G_STORE;
		scenedata[num].sdat[i].mojifgcolor = sdatver1_1.mojifgcolor;
		scenedata[num].sdat[i].mojibgcolor = sdatver1_1.mojibgcolor;
		scenedata[num].sdat[i].mojisizex   = sdatver1_1.mojisizex;
		scenedata[num].sdat[i].mojisizey   = sdatver1_1.mojisizey;
		scenedata[num].sdat[i].mojiattr    = sdatver1_1.mojiattr;
		offset += sizeof(SCENEDATAver1_1);
	    }
	    break;
	case 3: /* ver1.2 */
	    for (i = 0 ; i < scenedata[num].num ; i++) {
		if ((err = rea_rec(fd, offset, (B *)&sdatver1_2,
				   sizeof(SCENEDATAver1_2),
				   NULL, NULL)) < 0) {
		    printf("rea_rec error2 %d\n", err);
		    return;
		}	
		scenedata[num].sdat[i].type        = sdatver1_2.type;
		scenedata[num].sdat[i].id          = sdatver1_2.id;
		scenedata[num].sdat[i].r           = sdatver1_2.r;
		scenedata[num].sdat[i].pnum        = sdatver1_2.pnum;
		scenedata[num].sdat[i].dispmode    = sdatver1_2.dispmode;
		scenedata[num].sdat[i].mojifgcolor = sdatver1_2.mojifgcolor;
		scenedata[num].sdat[i].mojibgcolor = sdatver1_2.mojibgcolor;
		scenedata[num].sdat[i].mojisizex   = sdatver1_2.mojisizex;
		scenedata[num].sdat[i].mojisizey   = sdatver1_2.mojisizey;
		scenedata[num].sdat[i].mojiattr    = sdatver1_2.mojiattr;
		offset += sizeof(SCENEDATAver1_2);
	    }
	    break;
	case 4: /* ver1.3 */
	    for (i = 0 ; i < scenedata[num].num ; i++) {
		if ((err = rea_rec(fd, offset, (B *)&sdatver1_3,
				   sizeof(SCENEDATAver1_3),
				   NULL, NULL)) < 0) {
		    printf("rea_rec error2 %d\n", err);
		    return;
		}	
		scenedata[num].sdat[i].type        = sdatver1_3.type;
		scenedata[num].sdat[i].id          = sdatver1_3.id;
		scenedata[num].sdat[i].r           = sdatver1_3.r;
		scenedata[num].sdat[i].pnum        = sdatver1_3.pnum;
		scenedata[num].sdat[i].dispmode    = sdatver1_3.dispmode;
		scenedata[num].sdat[i].mojifgcolor = sdatver1_3.mojifgcolor;
		scenedata[num].sdat[i].mojibgcolor = sdatver1_3.mojibgcolor;
		scenedata[num].sdat[i].mojisizex   = sdatver1_3.mojisizex;
		scenedata[num].sdat[i].mojisizey   = sdatver1_3.mojisizey;
		scenedata[num].sdat[i].mojiattr    = sdatver1_3.mojiattr;
		offset += sizeof(SCENEDATAver1_3);
	    }
	    break;
	case 5: /* ver1.4 */
	    if ((err = rea_rec(fd, offset, (B *)scenedata[num].sdat,
			       sizeof(SCENEDATAver1_4) * scenedata[num].num,
			       NULL, NULL)) < 0) {
		printf("rea_rec error3 %d\n", err);
		return;
	    }
	    offset += sizeof(SCENEDATAver1_4) * scenedata[num].num;
	}
    }
}

/* widμɥĶrμϰϤˤ scenenum ֹΥ
   衣
   ѡĤ褹ѡID pid ǡpnumܤ
   ܤ˳Ǽιܤ0ǤʤϿ˥ѡĤĤ뤳ȤϤʤ
   pnum  pmax ۤʤˤ⤷ʤ
   ʤѡĤϹԤʤ */
void displayscene(W wid, W scenenum, W *pid, W pmax, RECT *hr)
{
    W 		i, vgid, type, id, pnum, gid, size, dispmode;
    BMP 	bmp;
    RECT 	checkrect, r, r2;
    PNT         pnt;

    if (hr) {
	r = *hr;
    }
    else {
	wget_wrk(wid, &r);
    }

#if 0
    gid = wget_gid(wid);
    /* Ķ(Ϥߤʬν˻Ȥ */
    bmp.bounds = r;
    bmp.planes = 1;
    bmp.pixbits = 0x0808;
    bmalloc(&bmp);

    vgid = gopn_mem(DEV_SCREEN, &bmp, NULL);
#endif
    vgid = gid = wget_gid(wid);
    
{    
	static	PAT	pat0 = {{0, 16, 16, 0x10ffffff, 0, FILL100}};
	gfil_rec(vgid, r, &pat0, 0, G_STORE);
}
/*    gfil_rec(vgid, r, (PAT *)FILL0, 0, G_STORE);*/

    for (i = 0 ; i < scenedata[scenenum].num ; i++) {
	type     = scenedata[scenenum].sdat[i].type;
	id       = scenedata[scenenum].sdat[i].id;
	pnum     = scenedata[scenenum].sdat[i].pnum;
	r2       = scenedata[scenenum].sdat[i].r;
	dispmode = scenedata[scenenum].sdat[i].dispmode;
	orrect(&checkrect, &r, &r2);
	if (!emptyrect(checkrect)) {
	    switch (type) {
	    case PTR_DATA:
		displaynodata(vgid, &r2);
		break;
	    case PAT_DATA:
		displaypatdatafromid(vgid, id, &r2, dispmode);
		break;		    
	    case PICT_DATA:
		displaypictdatafromid(vgid, id, &r2, dispmode);
		break;
	    case BMAP_DATA:
		displaybmpdatafromid(vgid, id, &r2, dispmode);
		break;
	    case FIG_DATA:
		displayfigdatafromid(vgid, id, &r2);
		break;
	    case TEXT_DATA:
		pnt.x = scenedata[scenenum].sdat[i].mojisizex;
		pnt.y = scenedata[scenenum].sdat[i].mojisizey;
		displaytextdatafromid(vgid, id, &r2, dispmode,
				scenedata[scenenum].sdat[i].mojiattr,
				&pnt,
				scenedata[scenenum].sdat[i].mojifgcolor,
				scenedata[scenenum].sdat[i].mojibgcolor);
		break;
	    case PARTS_DATA:
		if (pnum >= pmax) {
		    displaynodata(vgid, &r2);
		    break;
		}
		if (!pid[pnum]) {
		    createpartsdatafromid(wid, id, &r2, &(pid[pnum]));
		}
		break;
	    }
	}
    }
#if 0
    gcop_bmp(vgid, &r, gid, NULL, NULL, G_STORE);
    gcls_env(vgid);
    bfree(&bmp);
#endif
}

/* ǡܥåǡǼƤĥ꡼typeΥפidID
   ǡ򥵡¸ߤФΥǡؤΥݥ󥿤ptr˳Ǽ
   ʤХǡܥåɤΥǡĥ꡼˳ǼΥǡ
   ؤΥݥ󥿤ptr˳Ǽ롣
   ǡǤ֤ͤȤ1
   ĥ꡼ˤǡܥåˤ⤽Υǡ¸ߤʤ0֤ */
W searchtree(W type, W id, B **ptr)
{
    DATATREE *tptr, **insptr;
    W        l, size, partstype, rsize, rsize2, rsize3, rsize4,
             nitem;
    B	     *tmpptr, *tmpptr2;
    BMP      *bmp;
    CBMP     *newcbmp;
    
    insptr = &(root[type]);
    tptr = root[type];
    while (tptr) {
	if (id == tptr->id) {
	    *ptr = tptr->ptr;
	    return 1;
	}
	else if (id < tptr->id) {
	    insptr = &(tptr->stree);
	    tptr = tptr->stree;
	}
	else {
	    insptr = &(tptr->ltree);
	    tptr = tptr->ltree;
	}
    }
    {
	int err;
	if ((err = dget_dtp(type, id, (VOID**)&tmpptr2)) < 0) {
	    return 0;
	}
    }
    size = dget_siz(tmpptr2);
    if (size < 0) {
	return 0;
    }
    switch (type) {
    case PTR_DATA:
    case FIG_DATA:
    case TEXT_DATA:	
    case MENU_DATA:
	tmpptr = malloc(size);
	(*ptr) = tmpptr;
	memcpy(tmpptr, tmpptr2, size);
	break;
    case PICT_DATA:
    case BMAP_DATA:
	if (((CBMP *)tmpptr2)->compac == 0 &&
	    (bmp = getscreentypebmp(&(((CBMP *)tmpptr2)->bmp)))) {
	    newcbmp = (CBMP *)malloc(sizeof(CBMP));
	    newcbmp->compac = 0;
	    memcpy(&(newcbmp->bmp), bmp, sizeof(BMP));
	    free (bmp);
	    (*ptr) = (B *)newcbmp;
	}
	else {
	    tmpptr = malloc(size);
	    (*ptr) = tmpptr;
	    memcpy(tmpptr, tmpptr2, size);
	}
	break;
    case PAT_DATA:
	tmpptr = malloc(size);
	(*ptr) = tmpptr;
	memcpy(tmpptr, tmpptr2, size);
	if (((PAT *)tmpptr)->spat.kind == 1 &&
	    (bmp = getscreentypebmp(((PAT *)tmpptr)->mpat.bmap))) {
	    ((PAT *)tmpptr)->mpat.bmap = bmp;
	}
	break;
    case PARTS_DATA:
	memcpy(&partstype, tmpptr2, sizeof(W));
	switch (partstype & 0x1f) {
	case TB_PARTS:
	case XB_PARTS:
	    rsize = sizeof(TEXTBOX) -
		((partstype & P_PARTDISP) ? 0 : sizeof(PARTDISP));
	    tmpptr = malloc(sizeof(TEXTBOX));
	    (*ptr) = tmpptr;
	    memcpy(tmpptr, tmpptr2, rsize);
	    tmpptr = malloc(size - rsize);
	    memcpy(tmpptr, tmpptr2 + rsize, size - rsize);
	    ((PARTS *)(*ptr))->tb.text = (TC *)tmpptr;
	    break;
	case SB_PARTS:
	    rsize = sizeof(SERBOX) -
		((partstype & P_PARTDISP) ? 0 : sizeof(PARTDISP));
	    tmpptr = malloc(sizeof(SERBOX));
	    (*ptr) = tmpptr;
	    memcpy(tmpptr, tmpptr2, rsize);
	    rsize2 = ((PARTS *)(*ptr))->sb.nfld * sizeof(W);
	    tmpptr = malloc(rsize2);
	    memcpy(tmpptr, tmpptr2 + rsize, rsize2);
	    ((PARTS *)(*ptr))->sb.cv = (W *)tmpptr;
	    tmpptr = malloc(size - rsize - rsize2);
	    memcpy(tmpptr, tmpptr2 + rsize + rsize2, size - rsize - rsize2);
	    ((PARTS *)(*ptr))->sb.fmt = (TC *)tmpptr;
	    break;
	case AS_PARTS:
	case MS_PARTS:
	case WS_PARTS:
	case SS_PARTS:
	    rsize = sizeof(SWSEL) -
		((partstype & P_PARTDISP) ? 0 : sizeof(PARTDISP));
	    tmpptr = malloc(sizeof(SWSEL));
	    (*ptr) = tmpptr;
	    memcpy(tmpptr, tmpptr2, rsize);
	    tmpptr = malloc(size - rsize);
	    memcpy(tmpptr, tmpptr2 + rsize, size - rsize);
	    ((PARTS *)(*ptr))->ss.name = (TC *)tmpptr;
	    break;	    
	default:
	    tmpptr = malloc(size);
	    (*ptr) = tmpptr;
	    memcpy(tmpptr, tmpptr2, size);
	    break;
	}
	break;
    case GMENU_DATA:
	rsize = sizeof(GMENU);
	if (rsize > size) {
	    rsize = size;
	}
	tmpptr = malloc(rsize);
	(*ptr) = tmpptr;
	memcpy(tmpptr, tmpptr2, rsize);

	rsize2 = sizeof(GMENU) -
	    (32 - ((GMENU *)(*ptr))->nitem) * sizeof(RECT);

	if (((GMENU *)(*ptr))->dnum == 0) {
	    tmpptr = malloc(size - rsize2);
	    memcpy(tmpptr, tmpptr2 + rsize2, size - rsize2);
	    ((GMENU *)(*ptr))->ptr = (TC *)tmpptr;
	}
	break;
    case PANEL_DATA:
	tmpptr = malloc(sizeof(PANEL));
	(*ptr) = tmpptr;
	rsize = sizeof(PANEL) - sizeof(PNL_ITEM *);
	memcpy(tmpptr, tmpptr2, rsize);
	tmpptr = malloc(size - rsize);
	memcpy(tmpptr, tmpptr2 + rsize, size - rsize);
	((PANEL *)(*ptr))->item = (PNL_ITEM *)tmpptr;
	break;
    }
    tmpptr = malloc(sizeof(DATATREE));
    (*insptr) = (DATATREE *)(tmpptr);
    (*insptr)->id    = id;
    (*insptr)->ptr   = *ptr;
    (*insptr)->stree = NULL;
    (*insptr)->ltree = NULL;
    return 1;
}

/* gidμĶ*rμ֤idμѥǡdispmode
   ⡼ɤ褹롣
   rNULLξϥѥ󥿥פ0ξ纸0Ȥɸˡ
   ѥ󥿥פ1ξpat->mpat.bmap.boundsμ֤褹롣
   ǡ¸ߤʤ*rΰ֤(rNULLξ(0,0,50,50)ΰ)
   ˻ͳѷ˼ο޷褹 */
void displaypatdatafromid(W gid, W id, RECT *r, W dispmode)
{
    PAT  *pat;
    
    if (!searchtree(PAT_DATA, id, (B **)&pat)) {
	displaynodata(gid, r);
	return;
    }
    displaypatdata(gid, pat, r, dispmode);
}

/* gidμĶ*rμ֤idμԥȥǡdispmode
   ⡼ɤ褹롣
   rNULLξcbmp->bmp.boundsμ֤褹롣
   ǡ¸ߤʤ*rΰ֤(rNULLξ(0,0,50,50)ΰ)
   ˻ͳѷ˼ο޷褹 */
void displaypictdatafromid(W gid, W id, RECT *r, W dispmode)
{
    CBMP *cbmp;
    
    if (!searchtree(PICT_DATA, id, (B **)&cbmp)) {
	displaynodata(gid, r);
	return;
    }
    displaypictdata(gid, cbmp, r, dispmode);
}

/* gidμĶ*rμ֤idμӥåȥޥåץǡdispmode
   ⡼ɤ褹롣
   rNULLξcbmp->bmp.boundsμ֤褹롣
   ǡ¸ߤʤ*rΰ֤(rNULLξ(0,0,50,50)ΰ)
   ˻ͳѷ˼ο޷褹 */
void displaybmpdatafromid(W gid, W id, RECT *r, W dispmode)
{
    CBMP *cbmp;
    
    if (!searchtree(BMAP_DATA, id, (B **)&cbmp)) {
	displaynodata(gid, r);
	return;
    }
    displaybmpdata(gid, cbmp, r, dispmode);
}

/* gidμĶ*rptrμ֤idμ޷ȥǡ
   褹롣rNULLξϤο޷ΰ֤Ԥ
   ǡ¸ߤʤ*rΰ֤(rNULLξ(0,0,50,50)ΰ)
   ˻ͳѷ˼ο޷褹 */
void displayfigdatafromid(W gid, W id, RECT *rptr)
{
    B * figdata;
    
    if (!searchtree(FIG_DATA, id, (B **)&figdata)) {
	displaynodata(gid, rptr);
    }
    displayfigdata(gid, figdata, rptr);
}

/* gidμĶ*rμ֤idμʸǡdispmode
   ⡼ɡattrե°*mojisizeʸ
   fgcolor,bgcolorʸ褹롣
   rNULLξϤο޷ΰ֤Ԥ
   mojisizeNULLξʸΥ16x16褵롣
   ǡ¸ߤʤ*rΰ֤(rNULLξ(0,0,50,50)ΰ)
   ˻ͳѷ˼ο޷褹 */
void displaytextdatafromid(W gid, W id, RECT *r, W dispmode, W attr,
			   PNT *mojisize, W fgcolor, W bgcolor)
{
    TC *tptr;
    
    if (!searchtree(TEXT_DATA, id, (B **)&tptr)) {
	displaynodata(gid, r);
	return;
    }
    displaytextdata(gid, tptr, r, dispmode, attr,
		    mojisize, fgcolor, bgcolor);
}

/* widμɥ*rptrμ֤idμѡĥǡϿ
   *pidϿѡĤΥѡIDǼ롣ʤδؿϿ
   ԤѡĤϹԤʤΤդ
   rNULLξϤΥѡΰ֤ϿԤ
   ǡ¸ߤʤ*rΰ֤(rNULLξ(0,0,50,50)ΰ)
   ˻ͳѷ˼ο޷褹 */
void createpartsdatafromid(W wid, W id, RECT *r, W *pid)
{
    PARTS *parts;
    
    if (!searchtree(PARTS_DATA, id, (B **)&parts)) {
	displaynodata(wget_gid(wid), r);
	return;
    }
    createpartsdata(wid, parts, r, pid);
}

/* *rΰ֤(rNULLξ(0,0,50,50)ΰ)˻ͳѷ˼ο޷
   褹 */
void displaynodata(W gid, RECT *r)
{
    RECT r2;
    PNT  p2;
    
    if (r) {
	r2 = *r;
    }
    else {
	setrect(r2, 0, 0, 50, 50);
    }
    gfil_rec(gid, r2, (PAT *)FILL0, 0, G_STORE);
    gfra_rec(gid, r2, 1, (PAT *)FILL100, 0, G_STORE);
    p2 = r2.p.rightbot;
    p2.x--;
    p2.y--;
    gdra_lin(gid, r2.p.lefttop, p2, 1, (PAT *)FILL100, G_STORE);
}

BMP *getscreentypebmp(BMP *bmp)
{
    W x, y;
    BMP *newbmp;
    B *fbptr, *fbptr2, *tbptr, *tbptr2;
    H *fhptr, *fhptr2, *thptr, *thptr2;
    W *fwptr, *fwptr2, *twptr, *twptr2;

    if (bmp->planes != 1 || bmp->pixbits == SCREEN.pixbits) {
	return NULL;
    }
    else {
	newbmp = malloc(sizeof(BMP));
	newbmp->planes = 1;
	memcpy(&(newbmp->bounds), &(bmp->bounds), sizeof(RECT));
	switch (SCREEN.pixbits) {
	case 0x0808:
	    newbmp->pixbits = 0x0808;
	    bmalloc(newbmp);
	    tbptr = newbmp->baseaddr[0];
	    switch(bmp->pixbits) {
	    case 0x1010:
		fhptr = (H *)bmp->baseaddr[0];
		for (y = 0 ; y < bmp->bounds.c.bottom -
		     bmp->bounds.c.top ; y++) {
		    tbptr2 = tbptr;
		    fhptr2 = fhptr;
		    for (x = 0 ; x < bmp->bounds.c.right -
			 bmp->bounds.c.left ; x++) {
			*(tbptr2++) = getcolmap16(*(fhptr2++));
		    }
		    tbptr += newbmp->rowbytes;
		    fhptr += bmp->rowbytes / sizeof(H);
		}
		break;
	    case 0x2018:
		fwptr = (W *)bmp->baseaddr[0];
		for (y = 0 ; y < bmp->bounds.c.bottom -
		     bmp->bounds.c.top ; y++) {
		    tbptr2 = tbptr;
		    fwptr2 = fwptr;
		    for (x = 0 ; x < bmp->bounds.c.right -
			 bmp->bounds.c.left ; x++) {
			*(tbptr2++) = getcolmap24(*(fwptr2++));
		    }
		    tbptr += newbmp->rowbytes;
		    fwptr += bmp->rowbytes / sizeof(W);
		}
		break;
	    default:
		bfree(newbmp);
		free(newbmp);
		return NULL;
		break;
	    }
	    break;
	case 0x1010:
	    newbmp->pixbits = 0x1010;
	    bmalloc(newbmp);
	    thptr = (H *)newbmp->baseaddr[0];
	    switch(bmp->pixbits) {
	    case 0x0808:
		fbptr = bmp->baseaddr[0];
		for (y = 0 ; y < bmp->bounds.c.bottom -
		     bmp->bounds.c.top ; y++) {
		    thptr2 = thptr;
		    fbptr2 = fbptr;
		    for (x = 0 ; x < bmp->bounds.c.right -
			 bmp->bounds.c.left ; x++) {
			*(thptr2++) = get16colfromcmap(*(fbptr2++));
		    }
		    thptr += newbmp->rowbytes / sizeof(H);
		    fbptr += bmp->rowbytes;
		}
		break;
	    case 0x2018:
		fwptr = (W *)bmp->baseaddr[0];
		for (y = 0 ; y < bmp->bounds.c.bottom -
		     bmp->bounds.c.top ; y++) {
		    thptr2 = thptr;
		    fwptr2 = fwptr;
		    for (x = 0 ; x < bmp->bounds.c.right -
			 bmp->bounds.c.left ; x++) {
			*(thptr2++) = get16colfrom32(*(fwptr2++));
		    }
		    thptr += newbmp->rowbytes / sizeof(H);
		    fwptr += bmp->rowbytes / sizeof(W);
		}
		break;
	    default:
		bfree(newbmp);
		free(newbmp);
		return NULL;
	    }
	    break;
	case 0x2018:
	    newbmp->pixbits = 0x2018;
	    bmalloc(newbmp);
	    twptr = (W *)newbmp->baseaddr[0];
	    switch(bmp->pixbits) {
	    case 0x0808:
		fbptr = bmp->baseaddr[0];
		for (y = 0 ; y < bmp->bounds.c.bottom -
		     bmp->bounds.c.top ; y++) {
		    twptr2 = twptr;
		    fbptr2 = fbptr;
		    for (x = 0 ; x < bmp->bounds.c.right -
			 bmp->bounds.c.left ; x++) {
			*(twptr2++) = colmap[*(fbptr2++)];
		    }
		    twptr += newbmp->rowbytes / sizeof(W);
		    fbptr += bmp->rowbytes;
		}
		break;
	    case 0x1010:
		fhptr = (H *)bmp->baseaddr[0];
		for (y = 0 ; y < bmp->bounds.c.bottom -
		     bmp->bounds.c.top ; y++) {
		    twptr2 = twptr;
		    fhptr2 = fhptr;
		    for (x = 0 ; x < bmp->bounds.c.right -
			 bmp->bounds.c.left ; x++) {
			*(twptr2++) = get32colfrom16(*(fhptr2++));
		    }
		    twptr += newbmp->rowbytes / sizeof(W);
		    fhptr += bmp->rowbytes / sizeof(H);
		}
		break;
	    default:
		bfree(newbmp);
		free(newbmp);
		return NULL;
	    }
	    break;
	default:
	    return NULL;
	}
    }
    return newbmp;
}

UB getcolmap16(H col)
{
    W r, g, b, diff, min, cr[256], cg[256], cb[256], i;
    B num;
    
    r = ((col & 0xf800) >> 8) + ((col & 0xe000) >> 13);
    g = ((col & 0x07e0) >> 3) + ((col & 0x0600) >> 9);
    b = ((col & 0x001f) << 3) + ((col & 0x001c) >> 2);
    min = 100000000;
    for (i = 0 ; i < 256 ; i++) {
	cr[i] = (colmap[i] & 0x00ff0000) >> 16;
	cg[i] = (colmap[i] & 0x0000ff00) >> 8;
	cb[i] = colmap[i] & 0x000000ff;
    }
    for (i = 0 ; i < 256 ; i++) {
	diff = (r - cr[i]) * (r - cr[i]) + (g - cg[i]) * (g - cg[i]) +
	    (b - cb[i]) * (b - cb[i]);
	if (diff < min) {
	    min = diff;
	    num = i;
	}
    }
    return num;
}

UB getcolmap24(W col)
{
    W r, g, b, diff, min, cr[256], cg[256], cb[256], i;
    B num;
    
    r = (col & 0x00ff0000) >> 16;
    g = (col & 0x0000ff00) >> 8;
    b = col & 0x000000ff;
    min = 100000000;
    for (i = 0 ; i < 256 ; i++) {
	cr[i] = (colmap[i] & 0x00ff0000) >> 16;
	cg[i] = (colmap[i] & 0x0000ff00) >> 8;
	cb[i] = colmap[i] & 0x000000ff;
    }
    for (i = 0 ; i < 256 ; i++) {
	diff = (r - cr[i]) * (r - cr[i]) + (g - cg[i]) * (g - cg[i]) +
	    (b - cb[i]) * (b - cb[i]);
	if (diff < min) {
	    min = diff;
	    num = i;
	}
    }
    return num;
}

UH get16colfromcmap(B col)
{
    W tmp;

    tmp = colmap[col];
    return ((tmp & 0x00f80000) >> 8) + ((tmp & 0x0000fc00) >> 5) +
	((tmp & 0x000000f8) >> 3);
}

UH get16colfrom32(W col)
{
    return ((col & 0x00f80000) >> 8) + ((col & 0x0000fc00) >> 5) +
	((col & 0x000000f8) >> 3);
}

COLOR get32colfrom16(H col)
{
    return 0x10000000 + ((col & 0xf800) << 8) + ((col & 0xe000) << 3) +
	((col & 0x07e0) << 5) + ((col & 0x0600) >> 1) +
	((col & 0x001f) << 3) + ((col & 0x001c) >> 2);
}

